--- ${PACKAGE_NAME}
-- Nenue
-- 55 dd9b5f59632caa354ea70a2024b944dc3558e793
-- 55 dd9b5f59632caa354ea70a2024b944dc3558e793
-- Created: 4/22/2016 5:38 PM
local B = select(2,...).frame
local T = B:RegisterModule("ObjectiveTracker", _G.VeneerObjectiveWrapper, 'BuffFrame')
local ipairs = ipairs
local bprint = B.print('Block')
local Default, AutoQuest, Quest, Bonus, Cheevs = T.DefaultHandler, T.AutoQuest, T.Quest, T.Bonus, T.Cheevs
--- displays a reward popout and starts its animation chain
local tagPoint, tagAnchor, tagRelative, x, y
local REWARD_POPUP_FRAME = _G.VeneerRewardsPopOut

function REWARD_POPUP_FRAME:StartRewards()
  tagPoint, tagAnchor, tagRelative, x, y = 'TOPLEFT', self, 'TOPLEFT', 0, 0

end
function REWARD_POPUP_FRAME:AddReward(handler, rewardInfo, id)
  local totalHeight = 0
  REWARD_POPUP_FRAME:SetID(id)
  REWARD_POPUP_FRAME.handler = handler

  for i, rewardTile in ipairs(REWARD_POPUP_FRAME.rewardTile) do
    if rewardInfo[i] then
      local reward = rewardInfo[i]
      rewardTile:SetPoint(tagPoint, tagAnchor, tagRelative, -2, -2)
      rewardTile:SetTexture(reward.texture)
      rewardTile:Show()
      if reward.count and reward.count > 1 then
        self.rewardLabel[i]:SetText(reward.count)
        self.rewardLabel[i]:Show()
      end

      rewardTile:ClearAllPoints()
      rewardTile:SetPoint(tagPoint, tagAnchor, tagRelative, x, y)
      tagPoint, tagAnchor, tagRelative, x, y = 'TOPRIGHT', rewardTile, 'TOPLEFT', -2, 0

      totalHeight = totalHeight + rewardTile:GetHeight()
    else
      rewardTile:Hide()
      self.rewardLabel[i]:Hide()
    end
  end

  REWARD_POPUP_FRAME.rewardsFadeIn:Play()
end

function REWARD_POPUP_FRAME:OnFinished ()
end

